#include "testlib.h"
#include <vector>
#include <iostream>

using namespace std;

int k, x, y;

template<typename T>
string to_string(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}

//0--knave, 1--knight
bool ok(int who, int cnt0, int cnt1)
{
    bool res = true;
    if (y != -1)
        res &= (cnt0 == y);
    if (x != -1)
        res &= (cnt1 == x);
    if (who == 0)
        res = !res;
    return res;
}

template<typename T>
string check(T &ouf, int &min_ans, int &max_ans, vector<vector<vector<int>>> &ans) //ans[2][2][k] 
{
    ans.assign(2, vector<vector<int>>(2, vector<int>(k, -1)));
    vector<int> a(2);
    for (int j = 0; j < 2; j++)
    {
        a[j] = ouf.readInt(-1, 2 * k, ("ans" + to_string(j + 1)).c_str());
        //string line = ouf.readLine();
        if (a[j] == -1)
        {
            if (j == 0)
                return "-1";
            return "-1 in 3 line";
        }

        int cur = 0;
        for (int i = 0; i < 2; i++)
        {
            string line = ouf.readToken();
            if ((int)line.size() != k)
                return "Incorrect line length " + to_string(3 * j + 2 + i); 
            for (int l = 0; l < k; l++)
            {
                if (line[l] != '0' && line[l] != '1')
                    return "Incorrect char in " + to_string(3 * j + 2 + i) + " line on " + to_string(l + 1) + " position";
                ans[j][i][l] = line[l] - '0';
                cur += line[l] - '0';  
            }
        }
        if (cur != a[j])
            return "ans" + to_string(j + 1) + " isn't sum of ones in sertificate";
        for (int i = 0; i < 2; i++)
        {
            int infront = (i + 1) % 2;
            for (int l = 0; l < k; l++)
            {
                int cnt[2] = {0, 0};
                int left = l - 1;
                if (left >= 0)
                    cnt[ans[j][i][left]]++;    
                int right = l + 1;
                if (right < k)
                    cnt[ans[j][i][right]]++;
                cnt[ans[j][infront][l]]++;
                if (!ok(ans[j][i][l], cnt[0], cnt[1]))
                    return "Condition doesn't sutisfied in " + to_string(3 * j + 2 + i) + " line on " + to_string(l + 1) + " position";
            }
        
        }
    }
    min_ans = a[0];
    max_ans = a[1]; 
    return "ok";
}


int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    k = inf.readInt();
    x = inf.readInt();
    y = inf.readInt();
    
    quitif(x == -1 && y == -1, _fail, "x = -1 & y = -1");
    
    vector<vector<vector<int>>> jans, cans;
    int jmin_ans, jmax_ans, cmin_ans, cmax_ans;

    string check_jury = check(ans, jmin_ans, jmax_ans, jans);
    quitif(check_jury != "ok" && check_jury != "-1", _fail, check_jury.c_str());
    
    string check_contestant = check(ouf, cmin_ans, cmax_ans, cans);
    quitif(check_contestant != "ok" && check_contestant != "-1", _wa, check_contestant.c_str());
    
    if (check_jury != check_contestant)
    {
        quitif(check_jury == "-1", _fail, "contestant find answer %d %d, jury does not", cmin_ans, cmax_ans);    
        quitif(check_contestant == "-1", _wa, "jury find answer %d %d, contestant does not", jmin_ans, jmax_ans);
    }

    quitif(check_jury == "-1", _ok, "-1");
    
    quitif(jmin_ans > jmax_ans, _fail, "jury has min_ans > max_ans");
    quitif(cmin_ans > cmax_ans, _wa, "contestant has min_ans > max_ans");
    

    quitif(jmin_ans > cmin_ans || jmax_ans < cmax_ans, _fail, "One of contestant answer is better :(");
    
    quitif(jmin_ans < cmin_ans, _wa, "contestant minimal answer isn't optimal: expected %d, find %d", jmin_ans, cmin_ans);
    quitif(jmin_ans > cmin_ans, _fail, "contestant minimal answer is better than jury: expected %d, find %d :(", jmin_ans, cmin_ans);
    
    quitif(jmax_ans > cmax_ans, _wa, "contestant maximal answer isn't optimal expected %d, find %d", jmax_ans, cmax_ans);
    quitif(jmax_ans < cmax_ans, _fail, "contestant maximal answer is better than jury: expected %d, find %d :(", jmax_ans, cmax_ans);
    

    quitf(_ok, "%d %d", jmin_ans, jmax_ans);
    return 0;
}