#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;
typedef long long ll;

const int GROUPS = 2;

const int MX = (int)(1e6);
const int N[GROUPS] = { (int)2e5, (int)2e5 };
const int C[GROUPS] = {       MX,       MX };

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	auto error = [&](string s) {
		cerr << s << endl;
		exit(1);
	};

	auto print = [&](vector<pair<int, int> > a) {
		cout << a.size() << endl;
		for (auto o : a) {
			cout << o.first << " " << o.second << endl;
		}
	};
    auto printEdges = [&](vector<pair<int, int> > e) {
        int v = -1;
        for (int i = 0; i < (int)e.size(); i++) {
            v = max(v, e[i].first + 1);
            v = max(v, e[i].second + 1); 
        }
        set<int> st;
        while ((int)st.size() < v) st.insert(rnd.next(1, MX));
        vector<int> vct;
        for (int x : st) vct.push_back(x);
        for (int i = 0; i < (int)e.size(); i++) if (rnd.next(2)) swap(e[i].first, e[i].second);
        shuffle(vct.begin(), vct.end());
        shuffle(e.begin(), e.end());
        vector<pair<int, int> > ans;
        for (int i = 0; i < (int)e.size(); i++) ans.push_back(make_pair(vct[e[i].first], vct[e[i].second]));
        print(ans);
    };

	if (argc < 1 + 1) {
		error("Usage: gen <test_type> [args...]");
	}

	string t = argv[1];

	if (t == "random_edges") {
		if (argc < 1 + 2) {
			error("Usage: gen random_edges <n>");
		}
		int n = atoi(argv[2]);
		set<int> st;
		while ((int)st.size() < n / 2) {
			st.insert(rnd.next(1, (int)1e6));
		}
		vector<int> a;
		for (int x : st) {
			a.push_back(x);
			a.push_back(x);
		}
		shuffle(a.begin(), a.end());
		vector<pair<int, int> > b;
		for (int i = 0; i < (int)a.size(); i += 2) {
			b.push_back(make_pair(a[i], a[i + 1]));
			b.push_back(make_pair(a[i + 1], a[i]));
		}
		print(b);
	}
	else if (t == "complete") {
		if (argc < 1 + 2) {
			error("Usage: gen complete <n>");
		}
		int m = atoi(argv[2]);
		vector<pair<int, int> > edges;
		int n = 1;
		while ((int)edges.size() < m) {
			for (int i = 1; i <= n; i++) {
				edges.push_back(make_pair(i, n + 1));
				edges.push_back(make_pair(i, n + 1));
			}
			n++;
		}
		edges.resize(m);
		shuffle(edges.begin(), edges.end());
		print(edges);
	}
	else if (t == "line") {
		if (argc < 1 + 2) {
			error("Usage: gen line <n>");
		}
		int m = atoi(argv[2]);
		int n = m / 2 - 1;
		set<int> st;
		while ((int)st.size() < n) st.insert(rnd.next(1, MX));
		vector<int> vct;
		for (int x : st) vct.push_back(x);

		vector<pair<int, int> > res;
		for (int i = 0; i < n - 1; i++) {
			res.push_back(make_pair(vct[i], vct[i + 1]));
			res.push_back(make_pair(vct[i], vct[i + 1]));
		}
		res.push_back(make_pair(vct[0], vct[2]));
		res.push_back(make_pair(vct[0], vct[2]));
		shuffle(res.begin(), res.end());
		print(res);
	}
    else if (t == "petersen") {
        if (argc < 1 + 4) {
            error("Usage: gen petersen <n> <garbage_edges> <has_cycle>");
        }
        int n = atoi(argv[2]);
        int ge = atoi(argv[3]);
        int fc = atoi(argv[4]); 

        int cur = 0;
        int v = 0;
        vector<pair<int, int> > e;
        while (2 * fc + cur + 30 + 30 * ge <= n) {
            vector<pair<int, int> > g;
            for (int i = 0; i < 5; i++) {
                int x = i;
                int y = (i + 1) % 5;
                if (x > y) swap(x, y);
                g.push_back(make_pair(x, y));
                g.push_back(make_pair(x, y));
            }  
            for (int i = 0; i < 5; i++) {
                int x = 5 + i;
                int y = 5 + (i + 2) % 5;
                if (x > y) swap(x, y);
                g.push_back(make_pair(x, y));
                g.push_back(make_pair(x, y));
            }
            for (int i = 0; i < 5; i++) {
                g.push_back(make_pair(i, i + 5));
                g.push_back(make_pair(i, i + 5));
            }
            if (ge) {
                for (int i = 0; i < 10; i++) {
                    for (int j = i + 1; j < 10; j++) {
                        if (find(g.begin(), g.end(), make_pair(i, j)) == g.end()) {
                            g.push_back(make_pair(i, j));
                        }
                    }
                }
            }
            for (int i = 0; i < (int)g.size(); i++) {
                e.push_back(make_pair(g[i].first + v, g[i].second + v));
            }
            v += 9;
            cur = e.size();
        }
        if (fc) {
            e.push_back(make_pair(0, 2));
            e.push_back(make_pair(0, 2));
        }
        set<int> st;
        while ((int)st.size() <= v) {
            st.insert(rnd.next(1, MX));
        }
        printEdges(e);
    }
    else if (t == "random_triangles") {
        if (argc < 1 + 2) {
            error("Usage: gen random_triangles <n>");
        }
        int n = atoi(argv[2]);
        vector<pair<int, int> > edges;
        int i = 1;
        for (; (int)edges.size() + 6 <= n; i++) {
            int j = rnd.next(i);
            int k = rnd.next(i);
            edges.push_back(make_pair(i, j));
            edges.push_back(make_pair(i, j));
            edges.push_back(make_pair(i, k));
            edges.push_back(make_pair(i, k));
            edges.push_back(make_pair(k, j));
            edges.push_back(make_pair(k, j));
        } 
        printEdges(edges);
    }
    else if (t == "unconnected") {
        if (argc < 1 + 3) {
            error("Usage: gen unconnected <n> <type>");
        } 
        int n = atoi(argv[2]);
        int type = atoi(argv[3]);
        vector<pair<int, int> > e;
        if (type == 0) {
            for (int i = 0; i < n; i++) e.push_back(make_pair(i * 2, i * 2 + 1));
        } else
        if (type == 1) {
            for (int i = 0; i < n / 2; i++) {
                e.push_back(make_pair(i * 2, i * 2 + 1));
                e.push_back(make_pair(i * 2, i * 2 + 1));
            }
        } else
        if (type == 2) {
            for (int i = 0; i < n / 6; i++) {
                e.push_back(make_pair(i * 3, i * 3 + 1));
                e.push_back(make_pair(i * 3, i * 3 + 1));
                e.push_back(make_pair(i * 3, i * 3 + 2));
                e.push_back(make_pair(i * 3, i * 3 + 2));
                e.push_back(make_pair(i * 3 + 2, i * 3 + 1));
                e.push_back(make_pair(i * 3 + 2, i * 3 + 1));
            }
        } else assert(0);
        printEdges(e);
    }
    else if (t == "star") {
        if (argc < 1 + 3) {
            error("Usage: gen star <n> <cycle>");
        }
        int n = atoi(argv[2]);
        int f = atoi(argv[3]);
        
        int k = (n - f * 2) / 2;
        vector<pair<int, int> > e;
        for (int i = 1; i < k; i++) {
            e.push_back(make_pair(0, i));
            e.push_back(make_pair(0, i));
        }
        if (f) {
            int x = rnd.next(1, k - 1);
            int y = rnd.next(1, k - 1);
            while (x == y) y= rnd.next(1, k - 1);
            e.push_back(make_pair(x, y));
            e.push_back(make_pair(x, y));
        }
        printEdges(e);
    }
    else if (t == "split") {
        if (argc < 1 + 2) {
            error("Usage: gen split <n>");
        }
        int n = atoi(argv[2]);
        int k = 1;
        while (2 * ((k + 1) * (k + 1) + (k + 1) * k / 2) <= n) {
            k++;
        }
        vector<pair<int, int> > e;
        for (int i = 0; i < k; i++) for (int j = i + 1; j < k; j++) {
            e.push_back({i, j});
            e.push_back({i, j});
        }
        for (int i = 0; i < k; i++) for (int j = k; j < k * 2; j++) {
            e.push_back({i, j});
            e.push_back({i, j});
        }
        printEdges(e);
    }
    else if (t == "ktree") {
        if (argc < 1 + 3) {
            error("Usage: gen ktree <n> <k>");
        }
        int n = atoi(argv[2]);
        int k = atoi(argv[3]);
        vector<pair<int, int> > e;
        int v = k + 1;
        for (int i = 0; i < k; i++) for (int j = 0; j <= k; j++) {
            e.push_back({i, j});
            e.push_back({i, j});
        }
        while ((int)e.size() + 2 * k <= n) {
            set<int> st;
            while ((int)st.size() < k) st.insert(rnd.next(v));
            for (int x : st) {
                e.push_back({x, v});
                e.push_back({x, v});
            }
            v++;
        }
        printEdges(e);
    }
    else if (t == "blocks") {
        if (argc < 1 + 3) {
            error("Usage: gen blocks <n> <k>");
        }
        int n = atoi(argv[2]);
        int k = atoi(argv[3]);
        int v = 1;
        vector<pair<int, int> > e;
        while ((int)e.size() + 2 <= n) {
            int sz = rnd.next(1, k);
            if ((int)e.size() + sz * (sz + 1) > n) continue;
            int p = rnd.next(v);
            for (int i = 0; i < sz; i++) {
                e.push_back({p, v + i});
                e.push_back({p, v + i});
                for (int j = i + 1; j < sz; j++) {
                    e.push_back({v + i, v + j});
                    e.push_back({v + i, v + j});
                }
            }
            v += sz;
        }
        printEdges(e);
    }
	else {
		error("<test_type>: \"" + t + "\" was not expected");
	}

	return 0;
}
