import random
from sys import argv, stderr

random.seed(" ".join(argv), 2)

n = 10**9
k = 200000
p = [0,0,0,0,0]
dorand = True

for s in argv[1:]:
	if '=' in s:
		if s[:s.find('=')] in ("n", "k", "p", "dorand") or s.startswith("p["):
			exec(s)
		else:
			print("Wrong argument", s, file=stderr)
			exit(1)

if type(n) != int:
	n = random.randint(n[0], n[1])
if type(k) != int:
	k = random.randint(k[0], k[1])
k = min(k, n * 2)

if max(p) == 0:
	p = [1,1,1,1,1]

def getType(p):
	x = random.randrange(sum(p))
	for i in range(5):
		if x < p[i]:
			return i
		x -= p[i]

print(n, k)
occ = set()
if n > k:
	order = None
else:
	order = [(i // 2, i % 2) for i in range(n * 2)]
	random.shuffle(order)

first = [0, 0]
last = [n - 1, n - 1]
for i in range(k):
	t = getType(p)
	if t == 0:
		x = min(first)
		y = 0 if first[0] <= first[1] else 1
	elif t == 1:
		x = min(first)
		y = 1 if first[0] >= first[1] else 0
	elif t == 2:
		x = max(last)
		y = 0 if last[0] >= last[1] else 1
	elif t == 3:
		x = max(last)
		y = 1 if last[0] <= last[1] else 0
	else: # t == 4
		if order == None:
			while True:
				xy = (random.randrange(n), random.randrange(2))
				if xy not in occ:
					break
		else:
			while order[-1] in occ:
				order.pop()
			xy = order[-1]
		x, y = xy
	
	if dorand and random.randrange(4) == 0:
		nx = x + random.randint(-4, 4)
		if 0 <= nx < n and (nx, y) not in occ:
			x = nx

	print(x + 1, y + 1)
	occ.add((x, y))
	while (first[y], y) in occ:
		first[y] += 1
	while (last[y], y) in occ:
		last[y] -= 1

